package de.hft.stuttgart.citydoctor2.datastructure;

import de.hft.stuttgart.citydoctor2.utils.CopyHandler;
import de.hft.stuttgart.citydoctor2.utils.Copyable;

import java.io.Serial;

public class BridgeRoom extends AbstractRoom {

    @Serial
    private static final long serialVersionUID = -276088332165299253L;

    private BridgeObject parent;

    private BridgeRoom() {
    }

    public BridgeRoom(BridgeObject parent) {
        this.parent = parent;
        parent.addBridgeRoom(this);
    }


    public void setGmlObject(org.citygml4j.core.model.bridge.BridgeRoom cgmlRoom) {
        super.cgmlRoom = cgmlRoom;
    }


    public BridgeObject getParent() {
        return parent;
    }

    @Override
    public void fillValues(Copyable original, CopyHandler handler) {
        super.fillValues(original, handler);
        BridgeRoom oRoom = (BridgeRoom) original;
        parent = handler.getCopyInstance(oRoom.getParent());
    }

    @Override
    public CityObject getTopLevelCityObject() {
        return getParent();
    }

    @Override
    public void collectInstances(CopyHandler handler) {
        super.collectInstances(handler);
        handler.addInstance(parent);
    }

    @Override
    public Copyable createCopyInstance() {
        return new BridgeRoom();
    }
}
