package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.Storey;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

import java.util.List;

public class AllStoreysNode extends Renderable{

    private final List<Storey> storeys;

    public AllStoreysNode(List<Storey> storeys) {
        this.storeys = storeys;
    }

    @Override
    public String getText() {
        return "Building Storeys";
    }

    @Override
    public void visit(Renderer renderer) {
        renderer.clearCurrentRender();
    }

    @Override
    public void refreshTextColor() {
        boolean wasChecked = false;
        for (Storey storey : storeys) {
            if (storey.isValidated()) {
                wasChecked = true;
                if (storey.containsAnyError()) {
                    setStatus(CheckStatus.ERROR);
                    return;
                }
            }
        }
        if (wasChecked) {
            setStatus(CheckStatus.OK);
        } else {
            setStatus(CheckStatus.NOT_CHECKED);
        }
    }

}
